#!/usr/bin/python

# Viscosity DNS Support Script
# http://www.viscosityvpn.com

import os, sys, re
from subprocess import *

# Update path for running instance to make sure we can find the programs
os.environ["PATH"] = '/bin:/sbin:/usr/sbin:/usr/bin'

# Get command line args
try:
    tun_dev, tun_mtu, link_mtu = sys.argv[1:4]
except:
	sys.exit(0)
	
# Get primary network interface
cmd = '''(scutil | grep PrimaryService | sed -e 's/.*PrimaryService : //')<< EOF
open
get State:/Network/Global/IPv4
d.show
quit
EOF'''
p = Popen(cmd, shell=True, stdin=PIPE, stdout=PIPE, stderr=STDOUT, close_fds=True)
networkInt = p.stdout.read()[:-1]

if os.path.isfile('/tmp/openvpn_dhcprestore'):
	os.remove('/tmp/openvpn_dhcprestore')

# Restore old settings
if os.path.isfile('/tmp/openvpn_domain_' + networkInt):
	tempfile = open('/tmp/openvpn_domain_' + networkInt, 'r')
	oldDomain = tempfile.read()
	tempfile.close()
	os.remove('/tmp/openvpn_domain_' + networkInt)
else:
	oldDomain = ''
	
if os.path.isfile('/tmp/openvpn_wins_' + networkInt):
	tempfile = open('/tmp/openvpn_wins_' + networkInt, 'r')
	oldWins = tempfile.read()
	tempfile.close()
	os.remove('/tmp/openvpn_wins_' + networkInt)
else:
	oldWins = ''

if os.path.isfile('/tmp/openvpn_dns_' + networkInt):
	tempfile = open('/tmp/openvpn_dns_' + networkInt, 'r')
	oldDNS = tempfile.read()
	tempfile.close()
	os.remove('/tmp/openvpn_dns_' + networkInt)
		
	# Remove DNS settings
	cmd = '''scutil << EOF
	open
	d.init
	d.add ServerAddresses * %s
	d.add DomainName %s
	set State:/Network/Service/%s/DNS
	d.init
	d.add WINSAddresses * %s
	set State:/Network/Service/%s/SMB
	quit
	EOF''' % (oldDNS, oldDomain, networkInt, oldWins, networkInt)
	p = Popen(cmd, shell=True, stdin=PIPE, stdout=PIPE, stderr=STDOUT, close_fds=True)
	p.stdout.read() # Wait for EOF
		
	resolv_file_path = '/etc/resolv.conf'
	if os.path.exists('/var/run/resolv.conf'):
		resolv_file_path = '/var/run/resolv.conf'

	resolv_file = file(resolv_file_path, 'r+')
	resolv_lines = resolv_file.readlines()

	START_SKIP = '# begin %s OpenVPN tunnel modifications' % tun_dev
	END_SKIP = '# end %s OpenVPN tunnel modifications' % tun_dev

	in_skip = False

	resolv_file.seek(0)
	resolv_file.truncate()
	for line in resolv_lines:
		if in_skip:
			if re.match(END_SKIP, line):
				in_skip = False
			continue
		else:
			if re.match(START_SKIP, line):
				in_skip = True
				continue
		if line == '\n': continue
		line = re.sub('# ', '', line)
		resolv_file.write(line)

	resolv_file.close()

if os.path.isfile('/tmp/openvpn_staticdns_' + networkInt):
	tempfile = open('/tmp/openvpn_staticdns_' + networkInt, 'r')
	staticDNS = tempfile.read()
	tempfile.close()
	os.remove('/tmp/openvpn_staticdns_' + networkInt)
		
	cmd = '''scutil << EOF
	open
	d.init
	d.add ServerAddresses * %s
	set Setup:/Network/Service/%s/DNS
	quit
	EOF''' % (staticDNS, networkInt)
	p = Popen(cmd, shell=True, stdin=PIPE, stdout=PIPE, stderr=STDOUT, close_fds=True)
	p.stdout.read() # Wait for EOF

cmd = 'dscacheutil -flushcache'
p = Popen(cmd, shell=True, stdin=PIPE, stdout=PIPE, stderr=STDOUT, close_fds=True)
p.stdout.read()
